using Gtk;
using System;

namespace Dizzy
{


	public class TaskTreeView
	{
		
		TreeView tree;
		
		TreeViewColumn fileColumn;
		TreeViewColumn progressColumn;
		// Gtk.TreeViewColumn statusColumn;
		
		ListStore tasklist;

		public TaskTreeView (Gtk.TreeView tree)
		{
			this.tree = tree;
			
			fileColumn = new TreeViewColumn ();
			fileColumn.Title = "File";
			
			progressColumn = new TreeViewColumn ();
			progressColumn.Title = "Avanzamento";
			
			this.tree.AppendColumn (fileColumn);
			this.tree.AppendColumn (progressColumn);
			
			tasklist = new ListStore (typeof(string),
			                          typeof(int));
			
			CellSetup ();
			this.tree.Model = tasklist;
		}
		
		protected void CellSetup ()
		{
			CellRendererText fileRenderer = new CellRendererText ();
			CellRendererProgress progressRenderer = new CellRendererProgress ();
			
			fileColumn.PackStart (fileRenderer, true);
			progressColumn.PackStart (progressRenderer, true);
			
			fileColumn.AddAttribute (fileRenderer, "text", 0);
			progressColumn.AddAttribute (progressRenderer, "value", 1);
		}
		
		
		// Ritorna un TreeIter all'elemento aggiunto
		public TreeIter AddTask (string name, int progress)
		{
			lock (this)
			{
				TreeIter iter = tasklist.AppendValues (name, progress);
				return iter;
			}
		}
		
		public void SetProgress (TreeIter iter, int progress)
		{
			lock (this)
			{
				tasklist.SetValue (iter, 1, progress);
			}
		}
		
		public void DeleteRow(TreeIter iter)
		{
			lock (this)
			{
				tasklist.Remove(ref iter);
			}
		}
	}
}
